//2010 0.1 Copyright (C) Michael Niedermayer 1997
#ifndef n2_7116
#define n2_7116

#define SAA7116_vendev 0x12238086

/*
 pci_cmd;   //04-05
 pci_sts;   //06-07
 rev;       //08
 classc1;   //09
 classc2;   //0A-0B
 res0C;     //0C
 mlt;       //0D
 headt;     //0E
 bist;      //0F
*/

struct meteor{
 byte  bus;
 byte  dev;
 byte  irq;
 dword base;
};

struct eo {
  u_long even;
  u_long odd;
};

struct eo3 {
  u_long even[3];
  u_long odd[3];
};

struct eo4 {
  u_long even[4];
  u_long odd[4];
};

struct rt_mode {
  unsigned mode:8;		/* 0:7  Pixel format for even fields */
  unsigned route:24;		/* 8:31 Pixel router mode for even fields */
};

struct ff_trig {
  unsigned packed:7;		/* 0:7(0:6) Fifo trigger Packed Mode */
  unsigned :9;			/* 8:15(7:15) Unused */
  unsigned planar:7;		/* 16:31(16:22) Fifo trigger Planar Mode */
  unsigned :9;			/* 23:31 Unused */
};

struct i2c_stat {
  unsigned :9;			/* 0:8 Not needed */
  unsigned d_abort:1;		/* 9:9 Status of i2c write: 0==success */
  unsigned :14;			/* 10:23 Not needed */
  unsigned r_data:8;		/* 24:31 Data returned by i2c read */
};

struct i2c_cmd {
  unsigned w_data:8;		/* 0:7 Data to be written out */
  unsigned reg_addr:8;		/* 8:15 Register address in device space */
  unsigned dev_addr:8;		/* 16:23 16: 0==write; 17:23: Device address */
  unsigned xfer:1;		/* 24: Set to start write. Clears when done */
  unsigned :7;			/* 25:31 Unused */
};

#define v_struct volatile struct

				/* (pointer-addition-values)hex-offset(s) */
struct saa7116 {
  struct eo3 dma;               /* ( 0-5 )00-14: Base address, e/o fields */
  struct eo3 stride;            /* ( 6-11)18-2c: Address stride, e/o fields */
  struct rt_mode rt_mode_e;	/* (12)30: Route and Mode for even fields */
  struct rt_mode rt_mode_o;	/* (13)34: Route and Mode for odd fields */
  struct ff_trig fifo_trigger;	/* (14)38 Fifo triggers: Planar and Packed */
  u_long field_toggle;		/* (15)3c */
  volatile u_long capt_ctl;	/* (16)40: Capture control, etc. */
  u_long retry_wait;		/* (17)44 */
  volatile u_long ints_ctl;	/* (18)48: Interrupt control and status */
  struct eo field_mask;         /* (19-20)4c-50 */
  u_long mask_lengths;		/* (21)54 */
  u_long fifo_limits;		/* (22)58 */
  u_long i2c_clocks;		/* (23)5c */
  v_struct i2c_stat i2c_stat;	/* (24)60 i2c mode control and status */
  v_struct i2c_cmd i2c_cmd;	/* (25)64 Direct mode command and data */
  struct eo4 i2c_auto;          /* (26-33)68-84*/
  u_long i2c_regs_enable;	/* (34)88 */
  struct eo dma_end;            /* (35-36)8c-90 */
};


int scan_pci_meteors(void);

#endif
