//2010 0.1 Copyright (C) Michael Niedermayer 1998

#include <stdlib.h>
#include <stdio.h>  //FIX ME (ONLY TEMP NEEDED)
#include <pc.h>
#include <go32.h>
#include <dpmi.h>
#include <sys/nearptr.h>
#include <signal.h>
#include <errno.h>
#include "2_all.h"
#include "2_hw.h"
#include "2_hw_asm.h"
#include "2_hw_mem.h"
#include "2_71x6.h"
#include "2_mouse.h"
#include "2_mmx.h"
#include "2010.h"

 extern int NoInt8;

 extern byte lock_start, lock_end;
 extern dword old_int8_vect_offset;
 extern  word old_int8_vect_selector;
 extern byte int8_handler;
 extern int bpp;

 extern volatile long timer_count;
 extern volatile __dpmi_regs mouse_regs;
 extern volatile int mouse_handler_enable;
 extern volatile int page_flip;
 extern volatile int yuvmode;
 extern volatile AllocList *alloclist;
 extern volatile grstate grab_state;
 extern volatile int fresh_cursor;
 extern volatile xxx dispbuf, grab_dispbuf;
 extern volatile int one_field;
 extern volatile int active_meteor;
 extern volatile meteor meteors[8];
 extern volatile int fields;
 extern int mouse_x,  mouse_y,  mouse_b;
 extern int mouse_lx, mouse_ly;
 extern byte *vidbuf;
 extern int xres, yres, xresc, xresvb, vb, mc;
 extern mouse_sprites cursor;
 extern char *yuv2rgb_lut;
 extern byte *mouse_buff[2];
 extern int amb;    //active_mouse_buffer
 extern int single;
 extern int in_int;
 extern int mouse_tim;
 extern int mouse_ltim;

 int g_mode=0;
 int m_mode=0;
 extern u_short my_cs, my_ds;
 asm("__esp: .long 0\n\t");

 static inline void setdot(int xx, int yy, s_col c);
 static inline s_col getdot(int xx, int yy);

void mem2vid(byte *to, s_yuv *from, int num, int bpp){
 int i;

 if(yuvmode!=0){
   num>>=1;
   if(bpp==32){
/*
     U Y1 V Y2

     esi from
     ebp to
     edi lut
     ecx counter
     eax (Y1 Y1 Y1 Y1 + LUT[ U ] + LUT[ V ]) | (Y2 Y2 Y2 Y2 + LUT[ U ] + LUT[ V ])
     ebx Y1 Y1 Y1 Y1 + LUT[ U ] + LUT[ V ]
     edx Y2 Y2 Y2 Y2 + LUT[ U ] + LUT[ V ] 
     esp  
  */
     asm(//"int $3                            \n\t"
         "pushl %%ebp                       \n\t"
         "movl %%eax, %%ebp                 \n\t"
         "movl %%esp, (__esp)               \n\t"

         "1:                                \n\t"
         "nop                               \n\t"       // U
         "movl (%%esi), %%eax               \n\t"       //  V 1
         "movl %%eax, %%ebx                 \n\t"       // U
         "movl %%eax, %%edx                 \n\t"       //  V 1
         "shrl $16, %%ebx                   \n\t"       // U
         "andl $0x000000FF, %%eax           \n\t"       //  V 1
         "andl $0x000000FF, %%ebx           \n\t"       // U
         "andl $0xFE00FE00, %%edx           \n\t"       //  V 1
         "shrl $1, %%edx                    \n\t"       // U
         "movl     (%%edi, %%eax, 4), %%eax \n\t"       //  V 1
         "movl 1024(%%edi, %%ebx, 4), %%ebx \n\t"       // U
         "movl %%edx, %%esp                 \n\t"       //  V 1
         "shrl $8, %%edx                    \n\t"       // U
         "addl %%ebx, %%eax                 \n\t"       //  V 1
         "orl %%edx, %%esp                  \n\t"       // U
         "addl $8, %%ebp                    \n\t"       //  V 1
         "movl %%esp, %%ebx                 \n\t"       // U
         "movl %%esp, %%edx                 \n\t"       //  V 1
         "shll $16, %%ebx                   \n\t"       // U
         "andl $0x0000FFFF, %%edx           \n\t"       //  V 1
         "orl %%edx, %%ebx                  \n\t"       // U
         "movl %%esp, %%edx                 \n\t"       //  V 1
         "shrl $16, %%edx                   \n\t"       // U
         "andl $0xFFFF0000, %%esp           \n\t"       //  V 1
         "orl %%esp, %%edx                  \n\t"       // U
         "addl %%eax, %%ebx                 \n\t"       //  V 1
         "addl %%eax, %%edx                 \n\t"       // U
         "movl %%ebx, %%eax                 \n\t"       //  V 1
         "orl %%edx, %%eax                  \n\t"       // U
         "addl $4, %%esi                    \n\t"       //  V 1
         "test $0x00808080, %%eax           \n\t"       // U
         " jz 2f                            \n\t"       //  V 1

         "movl %%ebx, %%eax                 \n\t"       // U
         "nop                               \n\t"       //  V 1
         "test $0x00800000, %%eax           \n\t"       // U
         " jz 10f                           \n\t"       //  V 1
         "test $0x00400000, %%eax           \n\t"       // U
         " jz 11f                           \n\t"       //  V 1
         "andl $0xFF00FFFF, %%ebx           \n\t"       // U
         "jmp 10f                           \n\t"       //  V 1
         "11:                               \n\t"
         "orl $0x00FF0000, %%ebx            \n\t"       // U
         "10:                               \n\t"       
         "test $0x00008000, %%eax           \n\t"       // U
         " jz 20f                           \n\t"       //  V 1
         "test $0x00004000, %%eax           \n\t"       // U
         " jz 21f                           \n\t"       //  V 1
         "andl $0xFFFF00FF, %%ebx           \n\t"       // U
         "jmp 20f                           \n\t"       //  V 1
         "21:                               \n\t"
         "orl $0x0000FF00, %%ebx            \n\t"       // U
         "20:                               \n\t"       
         "test $0x00000080, %%eax           \n\t"       // U
         " jz 30f                           \n\t"       //  V 1
         "test $0x00000040, %%eax           \n\t"       // U
         " jz 31f                           \n\t"       //  V 1
         "andl $0xFFFFFF00, %%ebx           \n\t"       // U
         "jmp 30f                           \n\t"       //  V 1
         "31:                               \n\t"
         "orl $0x000000FF, %%ebx            \n\t"       // U
         "30:                               \n\t"
         "movl %%edx, %%eax                 \n\t"       // U
         "nop                               \n\t"       //  V 1
         "test $0x00800000, %%eax           \n\t"       // U
         " jz 40f                           \n\t"       //  V 1
         "test $0x00400000, %%eax           \n\t"       // U
         " jz 41f                           \n\t"       //  V 1
         "andl $0xFF00FFFF, %%edx           \n\t"       // U
         "jmp 40f                           \n\t"       //  V 1
         "41:                               \n\t"
         "orl $0x00FF0000, %%edx            \n\t"       // U
         "40:                               \n\t"       
         "test $0x00008000, %%eax           \n\t"       // U
         " jz 50f                           \n\t"       //  V 1
         "test $0x00004000, %%eax           \n\t"       // U
         " jz 51f                           \n\t"       //  V 1
         "andl $0xFFFF00FF, %%edx           \n\t"       // U
         "jmp 50f                           \n\t"       //  V 1
         "51:                               \n\t"
         "orl $0x0000FF00, %%edx            \n\t"       // U
         "50:                               \n\t"       
         "test $0x00000080, %%eax           \n\t"       // U
         " jz 60f                           \n\t"       //  V 1
         "test $0x00000040, %%eax           \n\t"       // U
         " jz 61f                           \n\t"       //  V 1
         "andl $0xFFFFFF00, %%edx           \n\t"       // U
         "jmp 60f                           \n\t"       //  V 1
         "61:                               \n\t"
         "orl $0x000000FF, %%edx            \n\t"       // U
         "60:                               \n\t"

         "andl $0xFF7F7F7F, %%ebx           \n\t"       // U
         "andl $0xFF7F7F7F, %%edx           \n\t"       //  V 1

         "2:                                \n\t"
         "addl %%ebx, %%ebx                 \n\t"       // U
         "addl %%edx, %%edx                 \n\t"       //  V 1
         "movl %%ebx, -8(%%ebp)             \n\t"       // U
         "movl %%edx, -4(%%ebp)             \n\t"       //  V 1
         "decl %%ecx                        \n\t"       // U
         " jnz 1b                           \n\t"       //  V 1
         "movl (__esp), %%esp               \n\t"
         "popl %%ebp                        \n\t"
         :
         : "m" (xres<<1),
           "D" (yuv2rgb_lut), "S" (from), "a" (to), "c" (num)
         : "%eax", "%ebx", "%ecx", "%edx", "%esi", "%edi");






   }
   else{
     for(i=0; i<num; i++){
       to[i*6  ]= (byte)( from[i].y1 + yuv2rgb_lut[(int(from[i].u)<<1) + 1  ] );
       to[i*6+1]= (byte)( from[i].y1 + yuv2rgb_lut[(int(from[i].v)<<1) + 512] + yuv2rgb_lut[int(from[i].u)<<1] ); 
       to[i*6+2]= (byte)( from[i].y1 + yuv2rgb_lut[(int(from[i].v)<<1) + 513] ); 
       to[i*6+3]= (byte)( from[i].y2 + yuv2rgb_lut[(int(from[i].u)<<1) + 1  ] ); 
       to[i*6+4]= (byte)( from[i].y2 + yuv2rgb_lut[(int(from[i].v)<<1) + 512] + yuv2rgb_lut[int(from[i].u)<<1] ); 
       to[i*6+5]= (byte)( from[i].y2 + yuv2rgb_lut[(int(from[i].v)<<1) + 513] ); 
     }
   }
 }else{
   if(bpp==32) memcpy(to, from, num<<2);
   else{
     if(num>>2==0) return;
     asm("//int $3                   \n\t"
           "0:                       \n\t"
           "movl  (%%esi), %%eax     \n\t"    // U
           "movl 4(%%esi), %%edx     \n\t"    //  V 1
           "rorl $8, %%edx           \n\t"    // UV 1
           "movl %%edx, %%ebx        \n\t"    // U
           "andl $0xff000000, %%edx  \n\t"    //  V 1
           "orl %%edx, %%eax         \n\t"    // U
           "andl $0x0000ffff, %%ebx  \n\t"    //  V 1

           "movl %%eax, (%%edi)      \n\t"    // U
           "movl 8(%%esi), %%edx     \n\t"    //  V 1
           "rorl $16, %%edx          \n\t"    // UV 1
           "movl %%edx, %%eax        \n\t"    // U
           "andl $0xffff0000, %%edx  \n\t"    //  V 1
           "orl %%edx, %%ebx         \n\t"    // U
           "andl $0x000000ff, %%eax  \n\t"    //  V 1

           "movl %%ebx, 4(%%edi)     \n\t"    // U
           "movl 12(%%esi), %%edx    \n\t"    //  V 1
           "rorl $24, %%edx          \n\t"    // UV 1
           "orl %%edx, %%eax         \n\t"    // U

           "addl $16, %%esi          \n\t"    //  V 1
           "movl %%eax, 8(%%edi)     \n\t"    // U
           "addl $12, %%edi          \n\t"    //  V 1
           "decl %%ecx               \n\t"    // U
           " jnz 0b                  \n\t"    //  V 1
           :
           : "S" (from), "D" (to), "c" (num>>2)
           : "%eax", "%ebx", "%ecx", "%edx", "%esi", "%edi");

   }
 }
}

void disabled_call_mouse_handler(void){

  if(mouse_handler_enable==0) return;
  mouse_handler_enable=0;
  mouse_regs.x.ax=0;
  mouse_handler();
  mouse_regs.x.ax=1;
  mouse_handler_enable=1;
}

void mouse_handler(void){
 int i, j, k, l;
 color c;

 if((mouse_handler_enable==0 && mouse_regs.x.ax!=0) || in_int!=0) return;
 in_int++;

 mouse_b=mouse_regs.x.bx;
 mouse_x=mouse_regs.x.cx;
 mouse_y=mouse_regs.x.dx;

 if(mouse_x>=xres) mouse_x=xres-1;
 if(mouse_y>=yres) mouse_y=yres-1;
                          
 for(j=0; j < cursor.y && mouse_y + j - cursor.hoty < yres; j++){
   if(j + mouse_y - cursor.hoty>=0){
     for(i=0  ; i < cursor.x && mouse_x + i - cursor.hotx < xres; i++){
       if(  i + mouse_x - cursor.hotx>=0){
         k=cursor.data[i + (j + mouse_tim*cursor.y)*cursor.x];
   
         int d_x=mouse_x - mouse_lx + i;
         int d_y=mouse_y - mouse_ly + j;
         if(   d_x >= 0 && d_x < cursor.x
            && d_y >= 0 && d_y < cursor.y && fresh_cursor==0)
           c.c.a=*(u_long *)(mouse_buff[amb] + (d_x + d_y*cursor.x)*vb);
         else
           c.c=getdot(mouse_x + i - cursor.hotx, mouse_y + j - cursor.hoty);

         *(u_long *)(mouse_buff[amb^1] + (i + j*cursor.x)*vb)=c.c.a;
  
         if(k!=255)
           c.c.rgb.r= c.c.rgb.g= c.c.rgb.b= k<<3;
       
         setdot(mouse_x + i - cursor.hotx, mouse_y + j - cursor.hoty, c.c);
  
       }
     }
   }
 }
  
 for(j=0; j < cursor.y && mouse_ly + j - cursor.hoty < yres; j++){
   if(j + mouse_ly - cursor.hoty>=0){
     for(i=0; i < cursor.x && mouse_lx + i - cursor.hotx < xres; i++){
       if(  i + mouse_lx - cursor.hotx>=0){
         k=i - mouse_x + mouse_lx;
         l=j - mouse_y + mouse_ly;
         if(  k<0 || k>=cursor.x
           || l<0 || l>=cursor.y){

           if(cursor.data[i + (j + mouse_ltim*cursor.y)*cursor.x]!=255
              && fresh_cursor==0){
             c.c.a=*(u_long *)(mouse_buff[amb] + (i + j*cursor.x)*vb);
             setdot(mouse_lx + i - cursor.hotx, mouse_ly + j - cursor.hoty, c.c);             
           }
         }
       }
     }
   }
 }

 amb^=1;
 fresh_cursor=0;
 mouse_lx=mouse_x;
 mouse_ly=mouse_y;
 mouse_ltim=mouse_tim;
 mouse_tim=timer_count % cursor.z;


 in_int--;
}

static inline void setdot(int xx, int yy, s_col c){
 int ppvb=xx*vb + yy*xresvb;             

 if(page_flip==1) ppvb+=xresvb*yres;

  vidbuf[ppvb  ]=c.rgb.b;
  vidbuf[ppvb+1]=c.rgb.g;
  vidbuf[ppvb+2]=c.rgb.r;
}

static inline s_col getdot(int xx, int yy){
 int ppvb=xx*vb + yy*xresvb;             

 if(page_flip==1) ppvb+=xresvb*yres;

 return *(s_col* )(vidbuf + ppvb);;
}

void close_hw(void){
 __dpmi_regs r;
 __dpmi_paddr address;

 if(m_mode==1){
  r.x.ax=0;
  __dpmi_int(0x33, &r);   //reset mouse

  address.offset32=old_int8_vect_offset;
  address.selector=old_int8_vect_selector;
  __dpmi_set_protected_mode_interrupt_vector(8, &address);

 }
 m_mode=0;

 close_meteor();
 unlockall();
 unmapall();

 if(g_mode==1){
   r.x.ax = 0x4F02;
   r.x.bx = 0x0003;
   __dpmi_int(0x10, &r);
   r.x.ax = 0x0003;
   __dpmi_int(0x10, &r);
 }

 g_mode=0;

 dpmi_freeall(&alloclist);
 vds_freeall();
}

void sig_handler(int i){
 close_hw();
 signal(i, SIG_DFL); 
 raise(i);
}

void end_func(void){}

void init_hw(void){
 __dpmi_regs r; 
 static _go32_dpmi_seginfo mouse_info;
 __dpmi_paddr address;

 my_cs=_go32_my_cs();
 my_ds=_go32_my_ds();

 r.x.ax=0;
 __dpmi_int(0x33, &r);   //reset mouse
 if(r.x.ax==0) error(NoMouse);

 r.x.ax=7;
 r.x.cx=0;
 r.x.dx=xres;
 __dpmi_int(0x33, &r);   //set horizontal cursor range

 r.x.ax=8;
 r.x.cx=0;
 r.x.dx=yres;
 __dpmi_int(0x33, &r);   //set vertical cursor range

 r.x.ax=4;
 r.x.cx=0;
 r.x.dx=0;
 __dpmi_int(0x33, &r);   //set mouse pos

 // set Mouse Handler 

 save_selectors();

 if(__dpmi_get_protected_mode_interrupt_vector(8, &address)!=0) error(DPMI);
 old_int8_vect_offset  =address.offset32;
 old_int8_vect_selector=address.selector;

 m_mode=1;


 lock(&lock_start, &lock_end);

 lock(&disabled_call_mouse_handler, &end_func);

 lock(cursor.data   , cursor.data + cursor.x * cursor.y * cursor.z);

 lock(mouse_buff[0] , mouse_buff[0] + (cursor.x * cursor.y<<2) );
 lock(mouse_buff[1] , mouse_buff[1] + (cursor.x * cursor.y<<2) );

 lock(meteor_int_handler, meteor_int_handler_end);


 address.offset32=(unsigned long)(&int8_handler);
 address.selector=my_cs;
 if(NoInt8==0)
  if(__dpmi_set_protected_mode_interrupt_vector(8, &address)!=0) error(DPMI);


 mouse_info.pm_offset=(unsigned long) mouse_handler;

 if((_go32_dpmi_allocate_real_mode_callback_retf(&mouse_info, (__dpmi_regs*)(&mouse_regs)))
    !=0) error(MouseHand);

 r.x.ax=0x0c;
 r.x.cx=1+2+4+8+16+32+64;
 r.x.es=mouse_info.rm_segment;
 r.x.dx=mouse_info.rm_offset;
 __dpmi_int(0x33, &r);   //set Handler

}

VesaInfoBlock *get_vesa_info(void)
{
        static VesaInfoBlock info;
	__dpmi_regs r;

        strcpy((char *)&info, "VBE2");  //request vbe2-info
        dosmemput(&info, 4, __tb); // store in buffer

	/* Use the transfer buffer to store the results of VBE call */
        r.x.ax = 0x4F00;
	r.x.es = __tb / 16;
	r.x.di = 0;
	__dpmi_int(0x10, &r);
        if(r.x.ax!=0x004F) return 0;
        dosmemget(__tb, 512, &info);
        return &info;
}

ModeInfoBlock *get_mode_info(int mode)
{
         static ModeInfoBlock info;
	__dpmi_regs r;

	/* Use the transfer buffer to store the results of VBE call */
	r.x.ax = 0x4F01;
	r.x.cx = mode;
	r.x.es = __tb / 16;
	r.x.di = 0;
	__dpmi_int(0x10, &r);
        if(r.x.ax!=0x004F) return 0;
	dosmemget(__tb, sizeof(ModeInfoBlock), &info);
	return &info;
}

void set_start_disp(int x, int y){
 __dpmi_regs r; 

  r.x.ax=0x4F07;            //set/get start of display "window"
  r.x.cx=x;
  r.x.dx=y;
  r.x.bx=0;
  __dpmi_int(0x10, &r);
  if(r.x.ax!=0x4F) error(VESAFlip);
}

void copy_vidbuffer(void){
 int i, j;

 if(page_flip==0){
   for(i=0; i<yres; i++){
     mem2vid(vidbuf + i*xresvb, (s_yuv*)((byte*)(dispbuf.yuv) + i*xresc), xres, bpp); 

     if(mouse_y - cursor.hoty <= i && mouse_y + cursor.y - cursor.hoty > i){
       disabled_call_mouse_handler();
       mouse_handler_enable=0;
       int mouse__x =mouse_x            - cursor.hotx;
       int mouse__xe=mouse_x + cursor.x - cursor.hotx;
       int mouse__ye=mouse_y + cursor.y - cursor.hoty;

       if(mouse__x<0) mouse__x=0;
       else if(mouse__xe>=xres) mouse__xe=xres-1;
       if(mouse__ye>=yres) mouse__ye=yres-1;

       j=mouse__xe & (~1);

       for(; i < yres && i < mouse__ye; i++ ){
         mem2vid(vidbuf + i*xresvb, (s_yuv*)((byte*)(dispbuf.yuv) + i*xresc), mouse__x, bpp);
         mem2vid(vidbuf + i*xresvb + j*vb,
                   (s_yuv*)((byte*)(dispbuf.yuv) + (i*xresc + (j<<mc))),
                                                            xres - j - 1, bpp);
       }
       i--;
       mouse_handler_enable=1;
     }
   }
 }else if(page_flip==2){
   mem2vid(vidbuf+xresvb*yres, dispbuf.yuv, xres*yres, bpp);
   page_flip=1;
   fresh_cursor=1;
   disabled_call_mouse_handler();
   set_start_disp(0, yres);
 }else{
   mem2vid(vidbuf,            dispbuf.yuv, xres*yres, bpp);
   page_flip=2;
   fresh_cursor=1;
   disabled_call_mouse_handler();
   set_start_disp(0, 0);
 }

 if(grab_state==Skiped){
   volatile xxx temp=dispbuf;
   dispbuf=grab_dispbuf;
   grab_dispbuf=temp;

   grab_next();
   fields=0;  //FIX ME ? -1 or what       
   meteors[active_meteor].saa7116->capt_ctl=(capt_c){
       cont_even: 1, cont_odd: 1, sing_even: 0, sing_odd: 0,
       done_even: 1, done_odd: 1, VRSTN:     1, fifo_en:  1,
       corr_even: 1, corr_odd: 1, aerr_even: 1, aerr_odd: 1,
       res1:      0, corr_dis: 0, range_en:  1, res2:     0};
                                    //   0x8FF3 resume grab
   grab_state=NotReady;
 }
 else{
   meteors[active_meteor].saa7116->capt_ctl=(capt_c){
       cont_even: 1, cont_odd: 1, sing_even: 0, sing_odd: 0,
       done_even: 1, done_odd: 1, VRSTN:     1, fifo_en:  1,
       corr_even: 1, corr_odd: 1, aerr_even: 1, aerr_odd: 1,
       res1:      0, corr_dis: 0, range_en:  1, res2:     0};
                                    //   0x8FF3 resume grab
   grab_state=Waiting;
   while(grab_state==Waiting);

 }
/*
 printf("X\nDMA E0 START %X\n",  meteors[active_meteor].saa7116->dma.even[0]);
 printf("DMA E1 START %X\n",  meteors[active_meteor].saa7116->dma.even[1]);
 printf("DMA E2 START %X\n",  meteors[active_meteor].saa7116->dma.even[2]);
 printf("DMA O0 START %X\n",  meteors[active_meteor].saa7116->dma.odd[0]);
 printf("DMA O1 START %X\n",  meteors[active_meteor].saa7116->dma.odd[1]);
 printf("DMA O2 START %X\n",  meteors[active_meteor].saa7116->dma.odd[2]);

 printf("STRIDE E0 %X\n",  meteors[active_meteor].saa7116->stride.even[0]);
 printf("STRIDE E1 %X\n",  meteors[active_meteor].saa7116->stride.even[1]);
 printf("STRIDE E2 %X\n",  meteors[active_meteor].saa7116->stride.even[2]);
 printf("STRIDE O0 %X\n",  meteors[active_meteor].saa7116->stride.odd[0]);
 printf("STRIDE O1 %X\n",  meteors[active_meteor].saa7116->stride.odd[1]);
 printf("STRIDE O2 %X\n",  meteors[active_meteor].saa7116->stride.odd[2]);

 printf("DMA E END %X\n",  meteors[active_meteor].saa7116->dma_end.even);
 printf("DMA O END %X\n",  meteors[active_meteor].saa7116->dma_end.odd);
  */
}

u_long read_pci(int bus, int dev, int func, int reg, int size){
 confadd ca;
 u_long u;

 ca.a=0;
 ca.f.enable=1;
 ca.f.bus=bus;
 ca.f.dev=dev;
 ca.f.func=func;
 ca.f.reg=reg>>2;

 outportl(confadd_port, ca.a);             
 u=inportl(confdata_port);                 
 ca.f.enable=0;                            
 outportl(confadd_port, ca.a);             

 u >>= (reg & 3);
 u &=0xFFFFFFFF >> (32-(size<<3));

 return u;
}

void write_pci(int bus, int dev, int func, int reg, int size, u_long dat){
 confadd ca;
 u_long u;

 ca.a=0;
 ca.f.enable=1;
 ca.f.bus=bus;
 ca.f.dev=dev;
 ca.f.func=func;
 ca.f.reg=reg>>2;

 u=read_pci(bus, dev, func, reg, size);

 outportl(confadd_port, ca.a);

 if(size==4)      outportl(confdata_port             , dat);
 else if(size==2) outportw(confdata_port + (reg & 3) , dat);
 else             outportb(confdata_port + (reg & 3) , dat);

 ca.f.enable=0;
 outportl(confadd_port, ca.a);
}

int check_mmx(void){
 int ret;
 asm("movl $1, %%eax          \n\t"
     "cpuid                   \n\t" 
     "andl $0x00800000, %%edx \n\t"
     "shrl $23, %%edx         \n\t"
     : "=d"(ret)
     :
     : "%eax", "%ebx", "%ecx");

 return ret;
}
