//2010 0.1 Copyright (C) Michael Niedermayer 1998

#include <stdlib.h>
#include "2_all.h"
#include "2_menu.h"
#include "2_mfunc.h"
#include "2_gfunc.h"

 extern int xres, yres;
 extern int buttons, xpos, ypos, lxpos, lypos;
 extern int fysize;
 extern int me, mx, my;
 extern int infox, infoy, istate;
 extern int cstate;
 extern int yuvmode;
 extern int v_smooth;

 menu menu_main[mainend+1];
 menu menu_config[end_config+1];
 menu menu_hdeci[end_hdeci+1];
 menu menu_vdeci[end_vdeci+1];
 menu menu_std[end_std+1];

 int grabf=0;
 int init_menu=1;
 menu *submenu[8]={0,0,0,0,0,0,0,0};  // max 7 levels of submenus 
 int sub_x[8],  sub_y[8];
 int sub_m=-1,  sub_my;
 int sub_xcorr=0;
 int sub_i[8]={-1,-1,-1,-1,-1,-1,-1,-1};

void setmenu(void){
 int i;

 if(init_menu==1){
  init_menu=0;

  for(i=0; i<=mainend; i++){
   menu_main[i].submenu=NULL;
   menu_main[i].func=NULL;
  }

  for(i=0; i<=end_config; i++){
   menu_config[i].submenu=NULL;
   menu_config[i].func=NULL;
   menu_config[i].c.init(menuinfocolor);
  }
  for(i=0; i<end_hdeci; i++){
   menu_hdeci[i].submenu=NULL;
   menu_hdeci[i].func=hdeci;
  }
  menu_hdeci[i].func=NULL;

  for(i=0; i<end_vdeci; i++){
   menu_vdeci[i].submenu=NULL;
   menu_vdeci[i].func=vdeci;
  }
  menu_vdeci[i].func=NULL;

  for(i=0; i<end_std; i++){
   menu_std[i].submenu=NULL;
   menu_std[i].func=mstd;
  }
  menu_std[i].func=NULL;

  strcpy(menu_main[menuconfig].text,  "Config         ");
  menu_main[menuconfig].submenu=menu_config;
  menu_main[menuconfig].c.init(menuinfocolor);

  menu_config[menuinfo].func=infoonoff;
  menu_config[menucont].func=contonoff;
  menu_config[menuvsmooth].func=vsmoothonoff;

  menu_config[menuhdeci].func=menuf_hdeci;
  menu_config[menuhdeci].submenu=menu_hdeci;
  strcpy(menu_config[menuhdeci].text, "H-Decimation   ");

  strcpy(menu_hdeci[menuhtapa].text, "Auto");
  strcpy(menu_hdeci[menuhtapb].text, "Bypass");
  strcpy(menu_hdeci[menuhtap2].text, "2-Tap Filter");
  strcpy(menu_hdeci[menuhtap3].text, "3-Tap Filter");
  strcpy(menu_hdeci[menuhtap4].text, "4-Tap Filter");
  strcpy(menu_hdeci[menuhtap5].text, "5-Tap Filter");
  strcpy(menu_hdeci[menuhtap8].text, "8-Tap Filter");
  strcpy(menu_hdeci[menuhtap9].text, "9-Tap Filter");

  menu_config[menuvdeci].func=menuf_vdeci;
  menu_config[menuvdeci].submenu=menu_vdeci;
  strcpy(menu_config[menuvdeci].text, "V-Decimation   ");

  strcpy(menu_vdeci[menuvfila].text, "Auto");
  strcpy(menu_vdeci[menuvfilb].text, "Bypass");
  strcpy(menu_vdeci[menuvfil1].text, "Filter 1");
  strcpy(menu_vdeci[menuvfil2].text, "Filter 2");

  menu_config[menustd].func=menuf_std;
  menu_config[menustd].submenu=menu_std;
  strcpy(menu_config[menustd].text, "TV - Standart  ");

  strcpy(menu_std[menupal]  .text, "PAL");
  strcpy(menu_std[menuntsc] .text, "NTSC");
  strcpy(menu_std[menusecam].text, "SECAM");
  strcpy(menu_std[menuvc]   .text, "VideoCrypt");
  strcpy(menu_std[menunag]  .text, "Nagravision");

  strcpy(menu_main[menugrab].text, "Save as BMP");
  menu_main[menugrab].func=grabm;
  menu_main[menugrab].c.init(menugrabcolor);

  strcpy(menu_main[menuexit].text, "Exit / Quit");
  menu_main[menuexit].func=exit;
  menu_main[menuexit].c.init(menugrabcolor);

 }

 if(istate==1)
  strcpy(menu_config[menuinfo].text, "Info Off");
 else
  strcpy(menu_config[menuinfo].text, "Info On");

 if(v_smooth==1)
  strcpy(menu_config[menuvsmooth].text, "V-Smooth Off");
 else
  strcpy(menu_config[menuvsmooth].text, "V-Smooth On");

 if(cstate==1)
  strcpy(menu_config[menucont].text, "Control Off");
 else
  strcpy(menu_config[menucont].text, "Control On");
}

int find_menu_ysize(menu *m){
 int i;

 for(i=0; m[i].func!=NULL || m[i].submenu!=NULL; i++);
 return i;
}

int find_menu_xsize(menu *m){
 int i,j=0;

 for(i=0; m[i].func!=NULL || m[i].submenu!=NULL; i++){
  if(int(strlen(m[i].text))>j) j=strlen(m[i].text);
 }
 return j;
}

void disp_menu(menu *m, int mx, int my, int level){
 int i, j, k, l, mysize, mxsize;
 color c;

 level++;
 setmenu();
 mysize=find_menu_ysize(m);
 mxsize=find_menu_xsize(m);

 if(level==1){
  if(sub_m==-1 || me!=3){
   sub_my=ypos;
  }else{
   sub_y[sub_m]-=sub_my-ypos;
   sub_my=ypos;
  }
 }

 l=0;
 j=mx;
 if(level==1) j += sub_xcorr;
 if(j+mxsize*9>xres){
  j=xres-mxsize*9;
  k=sub_xcorr;
  sub_xcorr+=j-mx;
  for(i=0; i<level; i++) sub_x[i]+=sub_xcorr-k;
 }

 k=my;
 if((fysize+1)*(mysize)<=yres){
  if(k+(fysize+1)*(mysize)-2>yres){
   k=yres-(fysize+1)*(mysize)-2;
   sub_y[level-1]=k;
  }
  else if(my<0){
   k=0;
   sub_y[level-1]=k;
  }
 }else{
  if(my+(fysize+1)*(mysize)-2<=yres){
   k=yres-(fysize+1)*(mysize)-2;
   sub_y[level-1]=k;
  }

  else if(my>=0){
   k=0;
   sub_y[level-1]=k;
  }
 }
 for(i=0 ;m[i].func!=NULL || m[i].submenu!=NULL; i++){
  rect(j-1, k+(fysize+1)*i, j+mxsize*9, k+(fysize+1)*(i+1)-2, m[i].c.c);
  if(xpos>=j-1 && xpos<=j+mxsize*9 && ypos>=k+(fysize+1)*i
                                   && ypos<=k+(fysize+1)*(i+1)-2){
   c.c=m[i].c.c;
   if(yuvmode!=0) c.c.yuv.y1=c.c.yuv.y2= c.c.yuv.y1+64;
   else{          c.c.rgb.r+=64; c.c.rgb.g+=64; c.c.rgb.b+=64; }
   gprint(j, k+(fysize+1)*i, c.c, m[i].text);
   l=1;
   if(m[i].submenu!=NULL){
    sub_x[level]=j+mxsize*9+3;
    sub_y[level]=k+(fysize+1)*i;
    l=0;
    if(m[i].func!=NULL && sub_i[level]!=i) m[i].func(i);
    sub_i[level]=i;
    submenu[level+1]=0;
    sub_i[level+1]=-1;
    submenu[level]=m[i].submenu;
    sub_m=-1;
   }
   if(me==2){
    if(m[i].func!=NULL) m[i].func(i);
   }
   if(me==3 && sub_m==-1 && level!=1 && (fysize+1)*(mysize)>yres){
    sub_m=level-1;
   }
  }
  else{
   c.c=m[i].c.c;
   if(yuvmode!=0) c.c.yuv.y1=c.c.yuv.y2= c.c.yuv.y1-64;
   else{          c.c.rgb.r-=64; c.c.rgb.g-=64; c.c.rgb.b-=64; }
   gprint(j, k+(fysize+1)*i, c.c, m[i].text);
  }
 }
 if(l==0 && submenu[level]!=0){
  disp_menu(submenu[level], sub_x[level], sub_y[level], level);
 }else{
  submenu[level]=0;
  sub_i[level]=-1;
 }

 if(me==2){
  submenu[level]=0;
  sub_i[level]=-1;
  sub_m=-1;
  sub_xcorr=0;
 }
}
