//2010 0.1 Copyright (C) Michael Niedermayer 1998

#include <stdlib.h>
#include "2_move.h"
#include "2_all.h"
#include "2010.h"

extern int xpos, ypos, lxpos, lypos, xres, yres;
extern int yress, xress;
extern int infox, infoy, istate;
extern int conty_b, conty_s, conty_c, contx_b, contx_s, contx_c, cstate;
extern int fysize;
extern int bright, satur, contr;

pos_tab_list mpos_tab_list;

pos_tab::pos_tab(int fixed2, int *xs2, int xe2,
                             int *ys2, int ye2, int *state2,
                            void (*l_but2)(void), pos_tab *prev2){

 fixed=fixed2;
 xs=xs2;
 ys=ys2;
 ye=ye2;
 xe=xe2;
 state=state2;
 l_but=l_but2;
 next=NULL;
 prev=prev2;
}

int pos_tab::inside(int xp, int yp){
 
  return (*xs    <=xp && xe>=xp && *ys    <=yp && ye>=yp); //fix me do that inline
}

void pos_tab::move(int relx, int rely){

 if((fixed & 1)==0){
   *xs+=relx;
    xe+=relx;

    if(*xs<0   )  xe+=0    - *xs, *xs=0;
    if( xe>xres) *xs+=xres -  xe,  xe=xres;

 }
 if((fixed & 2)==0){
   *ys+=rely;
    ye+=rely;

    if(*ys<0   )  ye+=0    - *ys, *ys=0;
    if( ye>yres) *ys+=yres -  ye,  ye=yres;
 }
}

void pos_tab::press_l(void){

 if(l_but==NULL){
  (*state)^=1;
 }else{
  l_but();
 }
}

pos_tab * pos_tab_list::new_tab(int fixed2, int *xs2, int xe2,
                                            int *ys2, int ye2, int *state2,
                                          void (*l_but2)(void)){
 pos_tab *temp;

 temp=new pos_tab(fixed2, xs2, xe2,
                          ys2, ye2, state2, l_but2, end);
 if(temp!=NULL){

  if(start==NULL) start=end=temp;
  else{
   end->next=temp;
   end=temp;
  }

 }
 return temp;
}


void setmpos(void){

 infox=xres-20*9;
 infoy=2;
 if(mpos_tab_list.new_tab(0, &infox, infox -1,
                             &infoy, infoy -1,
                          &istate, NULL)           ==NULL) error(MemAlloc);
 contx_b=bright;
 conty_b=yress - 20;
 if(mpos_tab_list.new_tab(2, &contx_b, contx_b + 5,
                             &conty_b, conty_b + 15,
                          &cstate, (void (*)())-1)           ==NULL) error(MemAlloc);
 contx_c=contr;
 conty_c=yress - 40;
 if(mpos_tab_list.new_tab(2, &contx_c, contx_c + 5,
                             &conty_c, conty_c + 15,
                          &cstate, (void (*)())-1)           ==NULL) error(MemAlloc);
 contx_s=satur;
 conty_s=yress - 60;
 if(mpos_tab_list.new_tab(2, &contx_s, contx_s + 5,
                             &conty_s, conty_s + 15,
                          &cstate, (void (*)())-1)           ==NULL) error(MemAlloc);
}
